Skip to main content
FieldTypeDescriptionValue(s)
versionstringIndicates the schema used to decode the contents.v1alpha1
debugbooltrue
yes
false
no
machineMachineConfigProvides machine specific configuration options.
clusterClusterConfigProvides cluster specific configuration options.

machine

MachineConfig represents the machine-specific config values.
FieldTypeDescriptionValue(s)
typestringcontrolplane
worker
tokenstring
caPEMEncodedCertificateAndKey
certSANs[]string
controlPlaneMachineControlPlaneConfigProvides machine specific control plane configuration options.
kubeletKubeletConfigUsed to provide additional options to the kubelet.
pods[]Unstructured
networkNetworkConfigProvides machine specific network configuration options.
disksMachineDisk
installInstallConfig
filesMachineFile
envEnvGRPC_GO_LOG_VERBOSITY_LEVEL
GRPC_GO_LOG_SEVERITY_LEVEL
http_proxy
https_proxy
no_proxy
timeTimeConfigUsed to configure the machine’s time settings.
sysctlsmap[string]stringUsed to configure the machine’s sysctls.
sysfsmap[string]stringUsed to configure the machine’s sysfs.
registriesRegistriesConfig
systemDiskEncryptionSystemDiskEncryptionConfig
featuresFeaturesConfigFeatures describe individual Talos features that can be switched on or off.
udevUdevConfigConfigures the udev system.
loggingLoggingConfigConfigures the logging system.
kernelKernelConfigConfigures the kernel.
seccompProfilesMachineSeccompProfileConfigures the seccomp profiles for the machine.
nodeLabelsmap[string]string
nodeTaintsmap[string]string

controlPlane

MachineControlPlaneConfig machine specific configuration options.
FieldTypeDescriptionValue(s)
controllerManagerMachineControllerManagerConfigController manager machine specific configuration options.
schedulerMachineSchedulerConfigScheduler machine specific configuration options.

controllerManager

MachineControllerManagerConfig represents the machine specific ControllerManager config values.
FieldTypeDescriptionValue(s)
disabledboolDisable kube-controller-manager on the node.

scheduler

MachineSchedulerConfig represents the machine specific Scheduler config values.
FieldTypeDescriptionValue(s)
disabledboolDisable kube-scheduler on the node.

kubelet

KubeletConfig represents the kubelet config values.
FieldTypeDescriptionValue(s)
imagestringThe image field is an optional reference to an alternative kubelet image.
clusterDNS[]stringThe ClusterDNS field is an optional reference to an alternative kubelet clusterDNS ip list.
extraArgsmap[string]stringThe extraArgs field is used to provide additional flags to the kubelet.
extraMountsExtraMount
extraConfigUnstructured
credentialProviderConfigUnstructuredThe KubeletCredentialProviderConfig field is used to provide kubelet credential configuration.
defaultRuntimeSeccompProfileEnabledboolEnable container runtime default Seccomp profile.true
yes
false
no
registerWithFQDNbooltrue
yes
false
no
nodeIPKubeletNodeIPConfig
skipNodeRegistrationbooltrue
yes
false
no
disableManifestsDirectorybooltrue
yes
false
no

extraMounts[]

ExtraMount wraps OCI Mount specification.
FieldTypeDescriptionValue(s)
destinationstringDestination is the absolute path where the mount will be placed in the container.
typestringType specifies the mount kind.
sourcestringSource specifies the source path of the mount.
options[]stringOptions are fstab style mount options.
uidMappingsLinuxIDMapping
gidMappingsLinuxIDMapping
uidMappings[]
LinuxIDMapping represents the Linux ID mapping.
FieldTypeDescriptionValue(s)
containerIDuint32ContainerID is the starting UID/GID in the container.
hostIDuint32HostID is the starting UID/GID on the host to be mapped to ‘ContainerID’.
sizeuint32Size is the number of IDs to be mapped.
gidMappings[]
LinuxIDMapping represents the Linux ID mapping.
FieldTypeDescriptionValue(s)
containerIDuint32ContainerID is the starting UID/GID in the container.
hostIDuint32HostID is the starting UID/GID on the host to be mapped to ‘ContainerID’.
sizeuint32Size is the number of IDs to be mapped.

nodeIP

KubeletNodeIPConfig represents the kubelet node IP configuration.
FieldTypeDescriptionValue(s)
validSubnets[]string

network

NetworkConfig represents the machine’s networking config values.
FieldTypeDescriptionValue(s)
hostnamestringUsed to statically set the hostname for the machine.
interfacesDevice
nameservers[]string
extraHostEntriesExtraHostAllows for extra entries to be added to the /etc/hosts file
kubespanNetworkKubeSpanConfigures KubeSpan feature.
disableSearchDomainbooltrue
yes
false
no

interfaces[]

Device represents a network interface.
FieldTypeDescriptionValue(s)
interfacestring
deviceSelectorNetworkDeviceSelector
addresses[]string
routesRoute
bondBondBond specific options.
bridgeBridgeBridge specific options.
vlansVlanVLAN specific options.
mtuint
dhcpbool
ignoreboolIndicates if the interface should be ignored (skips configuration).
dummybool
dhcpOptionsDHCPOptions
wireguardDeviceWireguardConfig
vipDeviceVIPConfigVirtual (shared) IP address configuration.
deviceSelector
NetworkDeviceSelector struct describes network device selector.
FieldTypeDescriptionValue(s)
busPathstringPCI, USB bus prefix, supports matching by wildcard.
hardwareAddrstringDevice hardware address, supports matching by wildcard.
pciIDstringPCI ID (vendor ID, product ID), supports matching by wildcard.
driverstringKernel driver, supports matching by wildcard.
routes[]
Route represents a network route.
FieldTypeDescriptionValue(s)
networkstringThe route’s network (destination).
gatewaystringThe route’s gateway (if empty, creates link scope route).
sourcestringThe route’s source address (optional).
metricuint32The optional metric for the route.
mtuuint32The optional MTU for the route.
bond
Bond contains the various options for configuring a bonded interface.
FieldTypeDescriptionValue(s)
interfaces[]stringThe interfaces that make up the bond.
deviceSelectorsNetworkDeviceSelector
arpIPTarget[]string
modestring
xmitHashPolicystring
lacpRatestring
adActorSystemstring
arpValidatestring
arpAllTargetsstring
primarystring
primaryReselectstring
failOverMacstring
adSelectstring
miimonuint32
updelayuint32
downdelayuint32
arpIntervaluint32
resendIgmpuint32
minLinksuint32
lpIntervaluint32
packetsPerSlaveuint32
numPeerNotifuint8
tlbDynamicLbuint8
allSlavesActiveuint8
useCarrierbool
adActorSysPriouint16
adUserPortKeyuint16
peerNotifyDelayuint32
deviceSelectors[]
NetworkDeviceSelector struct describes network device selector.
FieldTypeDescriptionValue(s)
busPathstringPCI, USB bus prefix, supports matching by wildcard.
hardwareAddrstringDevice hardware address, supports matching by wildcard.
pciIDstringPCI ID (vendor ID, product ID), supports matching by wildcard.
driverstringKernel driver, supports matching by wildcard.
bridge
Bridge contains the various options for configuring a bridge interface.
FieldTypeDescriptionValue(s)
interfaces[]stringThe interfaces that make up the bridge.
stpSTP
stp
STP contains the various options for configuring the STP properties of a bridge interface.
FieldTypeDescriptionValue(s)
enabledboolWhether Spanning Tree Protocol (STP) is enabled.
vlans[]
Vlan represents vlan settings for a device.
FieldTypeDescriptionValue(s)
addresses[]stringThe addresses in CIDR notation or as plain IPs to use.
routesRouteA list of routes associated with the VLAN.
dhcpboolIndicates if DHCP should be used.
vlanIduint16The VLAN’s ID.
mtuuint32The VLAN’s MTU.
vipDeviceVIPConfigThe VLAN’s virtual IP address configuration.
dhcpOptionsDHCPOptions
routes[]
Route represents a network route.
FieldTypeDescriptionValue(s)
networkstringThe route’s network (destination).
gatewaystringThe route’s gateway (if empty, creates link scope route).
sourcestringThe route’s source address (optional).
metricuint32The optional metric for the route.
mtuuint32The optional MTU for the route.
vip
DeviceVIPConfig contains settings for configuring a Virtual Shared IP on an interface.
FieldTypeDescriptionValue(s)
ipstringSpecifies the IP address to be used.
equinixMetalVIPEquinixMetalConfigSpecifies the Equinix Metal API settings to assign VIP to the node.
hcloudVIPHCloudConfigSpecifies the Hetzner Cloud API settings to assign VIP to the node.
equinixMetal
VIPEquinixMetalConfig contains settings for Equinix Metal VIP management.
FieldTypeDescriptionValue(s)
apiTokenstringSpecifies the Equinix Metal API Token.
hcloud
VIPHCloudConfig contains settings for Hetzner Cloud VIP management.
FieldTypeDescriptionValue(s)
apiTokenstringSpecifies the Hetzner Cloud API Token.
dhcpOptions
DHCPOptions contains options for configuring the DHCP settings for a given interface.
FieldTypeDescriptionValue(s)
routeMetricuint32The priority of all routes received via DHCP.
ipv4boolEnables DHCPv4 protocol for the interface (default is enabled).
ipv6boolEnables DHCPv6 protocol for the interface (default is disabled).
duidv6stringSet client DUID (hex string).
dhcpOptions
DHCPOptions contains options for configuring the DHCP settings for a given interface.
FieldTypeDescriptionValue(s)
routeMetricuint32The priority of all routes received via DHCP.
ipv4boolEnables DHCPv4 protocol for the interface (default is enabled).
ipv6boolEnables DHCPv6 protocol for the interface (default is disabled).
duidv6stringSet client DUID (hex string).
wireguard
DeviceWireguardConfig contains settings for configuring Wireguard network interface.
FieldTypeDescriptionValue(s)
privateKeystring
listenPortintSpecifies a device’s listening port.
firewallMarkintSpecifies a device’s firewall mark.
peersDeviceWireguardPeerSpecifies a list of peer configurations to apply to a device.
peers[]
DeviceWireguardPeer a WireGuard device peer configuration.
FieldTypeDescriptionValue(s)
publicKeystring
endpointstringSpecifies the endpoint of this peer entry.
persistentKeepaliveIntervalDuration
allowedIPs[]stringAllowedIPs specifies a list of allowed IP addresses in CIDR notation for this peer.
vip
DeviceVIPConfig contains settings for configuring a Virtual Shared IP on an interface.
FieldTypeDescriptionValue(s)
ipstringSpecifies the IP address to be used.
equinixMetalVIPEquinixMetalConfigSpecifies the Equinix Metal API settings to assign VIP to the node.
hcloudVIPHCloudConfigSpecifies the Hetzner Cloud API settings to assign VIP to the node.
equinixMetal
VIPEquinixMetalConfig contains settings for Equinix Metal VIP management.
FieldTypeDescriptionValue(s)
apiTokenstringSpecifies the Equinix Metal API Token.
hcloud
VIPHCloudConfig contains settings for Hetzner Cloud VIP management.
FieldTypeDescriptionValue(s)
apiTokenstringSpecifies the Hetzner Cloud API Token.

extraHostEntries[]

ExtraHost represents a host entry in /etc/hosts.
FieldTypeDescriptionValue(s)
ipstringThe IP of the host.
aliases[]stringThe host alias.

kubespan

NetworkKubeSpan struct describes KubeSpan configuration.
FieldTypeDescriptionValue(s)
enabledbool
advertiseKubernetesNetworksbool
allowDownPeerBypassbool
harvestExtraEndpointsbool
mtuuint32
filtersKubeSpanFilters
filters
KubeSpanFilters struct describes KubeSpan advanced network addresses filtering.
FieldTypeDescriptionValue(s)
endpoints[]string

disks[]

MachineDisk represents the options available for partitioning, formatting, and mounting extra disks.
FieldTypeDescriptionValue(s)
devicestringThe name of the disk to use.
partitionsDiskPartitionA list of partitions to create on the disk.

partitions[]

DiskPartition represents the options for a disk partition.
FieldTypeDescriptionValue(s)
sizeDiskSizeThe size of partition: either bytes or human readable representation. If size: is omitted, the partition is sized to occupy the full disk.
mountpointstringWhere to mount the partition.

install

InstallConfig represents the installation options for preparing a node.
FieldTypeDescriptionValue(s)
diskstringThe disk used for installations.
diskSelectorInstallDiskSelector
extraKernelArgs[]string
imagestring
extensionsInstallExtensionConfigAllows for supplying additional system extension images to install on top of base Talos image.
wipebooltrue
yes
false
no
legacyBIOSSupportbool

diskSelector

InstallDiskSelector represents a disk query parameters for the install disk lookup.
FieldTypeDescriptionValue(s)
sizeInstallDiskSizeMatcherDisk size.
namestringDisk name /sys/block/{"<"}dev{">"}/device/name.
modelstringDisk model /sys/block/{"<"}dev{">"}/device/model.
serialstringDisk serial number /sys/block/{"<"}dev{">"}/serial.
modaliasstringDisk modalias /sys/block/{"<"}dev{">"}/device/modalias.
uuidstringDisk UUID /sys/block/{"<"}dev{">"}/uuid.
wwidstringDisk WWID /sys/block/{"<"}dev{">"}/wwid.
typeInstallDiskTypeDisk Type.ssd
hdd
nvme
sd
busPathstringDisk bus path.

extensions[]

InstallExtensionConfig represents a configuration for a system extension.
FieldTypeDescriptionValue(s)
imagestringSystem extension image.

files[]

MachineFile represents a file to write to disk.
FieldTypeDescriptionValue(s)
contentstringThe contents of the file.
permissionsFileModeThe file’s permissions in octal.
pathstringThe path of the file.
opstringThe operation to usecreate
append
overwrite

time

TimeConfig represents the options for configuring time on a machine.
FieldTypeDescriptionValue(s)
disabledbool
servers[]string
bootTimeoutDuration

registries

RegistriesConfig represents the image pull options.
FieldTypeDescriptionValue(s)
mirrorsmap[string]RegistryMirrorConfig
configmap[string]RegistryConfig

mirrors.*

RegistryMirrorConfig represents mirror configuration for a registry.
FieldTypeDescriptionValue(s)
endpoints[]string
overridePathbool

config.*

RegistryConfig specifies auth & TLS config per registry.
FieldTypeDescriptionValue(s)
tlsRegistryTLSConfigThe TLS configuration for the registry.
authRegistryAuthConfig
tls
RegistryTLSConfig specifies TLS config for HTTPS registries.
FieldTypeDescriptionValue(s)
clientIdentityPEMEncodedCertificateAndKey
caBase64Bytes
insecureSkipVerifyboolSkip TLS server certificate verification (not recommended).
auth
RegistryAuthConfig specifies authentication configuration for a registry.
FieldTypeDescriptionValue(s)
usernamestring
passwordstring
authstring
identityTokenstring

systemDiskEncryption

SystemDiskEncryptionConfig specifies system disk partitions encryption settings.
FieldTypeDescriptionValue(s)
stateEncryptionConfigState partition encryption.
ephemeralEncryptionConfigEphemeral partition encryption.

state

EncryptionConfig represents partition encryption settings.
FieldTypeDescriptionValue(s)
providerstringEncryption provider to use for the encryption.
keysEncryptionKeyDefines the encryption keys generation and storage method.
cipherstringCipher kind to use for the encryption. Depends on the encryption provider.aes-xts-plain64
xchacha12,aes-adiantum-plain64
xchacha20,aes-adiantum-plain64
keySizeuintDefines the encryption key length.
blockSizeuint64Defines the encryption sector size.
options[]stringAdditional —perf parameters for the LUKS2 encryption.no_read_workqueue
no_write_workqueue
same_cpu_crypt
keys[]
EncryptionKey represents configuration for disk encryption key.
FieldTypeDescriptionValue(s)
staticEncryptionKeyStaticKey which value is stored in the configuration file.
nodeIDEncryptionKeyNodeIDDeterministically generated key from the node UUID and PartitionLabel.
kmsEncryptionKeyKMSKMS managed encryption key.
slotintKey slot number for LUKS2 encryption.
tpmEncryptionKeyTPMEnable TPM based disk encryption.
static
EncryptionKeyStatic represents throw away key type.
FieldTypeDescriptionValue(s)
passphrasestringDefines the static passphrase value.
nodeID
EncryptionKeyNodeID represents deterministically generated key from the node UUID and PartitionLabel.
kms
EncryptionKeyKMS represents a key that is generated and then sealed/unsealed by the KMS server.
FieldTypeDescriptionValue(s)
endpointstringKMS endpoint to Seal/Unseal the key.
tpm
EncryptionKeyTPM represents a key that is generated and then sealed/unsealed by the TPM.
FieldTypeDescriptionValue(s)
checkSecurebootStatusOnEnrollbool

ephemeral

EncryptionConfig represents partition encryption settings.
FieldTypeDescriptionValue(s)
providerstringEncryption provider to use for the encryption.
keysEncryptionKeyDefines the encryption keys generation and storage method.
cipherstringCipher kind to use for the encryption. Depends on the encryption provider.aes-xts-plain64
xchacha12,aes-adiantum-plain64
xchacha20,aes-adiantum-plain64
keySizeuintDefines the encryption key length.
blockSizeuint64Defines the encryption sector size.
options[]stringAdditional —perf parameters for the LUKS2 encryption.no_read_workqueue
no_write_workqueue
same_cpu_crypt
keys[]
EncryptionKey represents configuration for disk encryption key.
FieldTypeDescriptionValue(s)
staticEncryptionKeyStaticKey which value is stored in the configuration file.
nodeIDEncryptionKeyNodeIDDeterministically generated key from the node UUID and PartitionLabel.
kmsEncryptionKeyKMSKMS managed encryption key.
slotintKey slot number for LUKS2 encryption.
tpmEncryptionKeyTPMEnable TPM based disk encryption.
static
EncryptionKeyStatic represents throw away key type.
FieldTypeDescriptionValue(s)
passphrasestringDefines the static passphrase value.
nodeID
EncryptionKeyNodeID represents deterministically generated key from the node UUID and PartitionLabel.
kms
EncryptionKeyKMS represents a key that is generated and then sealed/unsealed by the KMS server.
FieldTypeDescriptionValue(s)
endpointstringKMS endpoint to Seal/Unseal the key.
tpm
EncryptionKeyTPM represents a key that is generated and then sealed/unsealed by the TPM.
FieldTypeDescriptionValue(s)
checkSecurebootStatusOnEnrollbool

features

FeaturesConfig describes individual Talos features that can be switched on or off.
FieldTypeDescriptionValue(s)
rbacboolEnable role-based access control (RBAC).
stableHostnameboolEnable stable default hostname.
kubernetesTalosAPIAccessKubernetesTalosAPIAccessConfig
apidCheckExtKeyUsageboolEnable checks for extended key usage of client certificates in apid.
diskQuotaSupportbool
kubePrismKubePrism

kubernetesTalosAPIAccess

KubernetesTalosAPIAccessConfig describes the configuration for the Talos API access from Kubernetes pods.
FieldTypeDescriptionValue(s)
enabledboolEnable Talos API access from Kubernetes pods.
allowedRoles[]string
allowedKubernetesNamespaces[]stringThe list of Kubernetes namespaces Talos API access is available from.

kubePrism

KubePrism describes the configuration for the KubePrism load balancer.
FieldTypeDescriptionValue(s)
enabledboolEnable KubePrism support - will start local load balacing proxy.
portintKubePrism port.

udev

UdevConfig describes how the udev system should be configured.
FieldTypeDescriptionValue(s)
rules[]stringList of udev rules to apply to the udev system

logging

LoggingConfig struct configures Talos logging.
FieldTypeDescriptionValue(s)
destinationsLoggingDestinationLogging destination.

destinations[]

LoggingDestination struct configures Talos logging destination.
FieldTypeDescriptionValue(s)
endpointEndpointWhere to send logs. Supported protocols are “tcp” and “udp”.
formatstringLogs format.json_lines
endpoint
Endpoint represents the endpoint URL parsed out of the machine config.
FieldTypeDescriptionValue(s)

kernel

KernelConfig struct configures Talos Linux kernel.
FieldTypeDescriptionValue(s)
modulesKernelModuleConfigKernel modules to load.

modules[]

KernelModuleConfig struct configures Linux kernel modules to load.
FieldTypeDescriptionValue(s)
namestringModule name.
parameters[]stringModule parameters, changes applied after reboot.

seccompProfiles[]

MachineSeccompProfile defines seccomp profiles for the machine.
FieldTypeDescriptionValue(s)
namestringThe name field is used to provide the file name of the seccomp profile.
valueUnstructuredThe value field is used to provide the seccomp profile.

cluster

ClusterConfig represents the cluster-wide config values.
FieldTypeDescriptionValue(s)
idstringGlobally unique identifier for this cluster (base64 encoded random 32 bytes).
secretstring
controlPlaneControlPlaneConfigProvides control plane specific configuration options.
clusterNamestringConfigures the cluster’s name.
networkClusterNetworkConfigProvides cluster specific network configuration options.
tokenstringThe bootstrap token used to join the cluster.
aescbcEncryptionSecretstring
secretboxEncryptionSecretstring
caPEMEncodedCertificateAndKeyThe base64 encoded root certificate authority used by Kubernetes.
aggregatorCAPEMEncodedCertificateAndKey
serviceAccountPEMEncodedKeyThe base64 encoded private key for service account token generation.
apiServerAPIServerConfigAPI server specific configuration options.
controllerManagerControllerManagerConfigController manager server specific configuration options.
proxyProxyConfigKube-proxy server-specific configuration options
schedulerSchedulerConfigScheduler server specific configuration options.
discoveryClusterDiscoveryConfigConfigures cluster member discovery.
etcdEtcdConfigEtcd specific configuration options.
coreDNSCoreDNSCore DNS specific configuration options.
externalCloudProviderExternalCloudProviderConfigExternal cloud provider configuration.
extraManifests[]string
extraManifestHeadersmap[string]stringA map of key value pairs that will be added while fetching the extraManifests.
inlineManifestsClusterInlineManifest
adminKubeconfigAdminKubeconfigConfig
allowSchedulingOnControlPlanesboolAllows running workload on control-plane nodes.true
yes
false
no

controlPlane

ControlPlaneConfig represents the control plane configuration options.
FieldTypeDescriptionValue(s)
endpointEndpoint
localAPIServerPortint

endpoint

Endpoint represents the endpoint URL parsed out of the machine config.
FieldTypeDescriptionValue(s)

network

ClusterNetworkConfig represents kube networking configuration options.
FieldTypeDescriptionValue(s)
cniCNIConfig
dnsDomainstring
podSubnets[]stringThe pod subnet CIDR.
serviceSubnets[]stringThe service subnet CIDR.

cni

CNIConfig represents the CNI configuration options.
FieldTypeDescriptionValue(s)
namestringName of CNI to use.flannel
custom
none
urls[]string
flannelFlannelCNIConfig
flannel
FlannelCNIConfig represents the Flannel CNI configuration options.
FieldTypeDescriptionValue(s)
extraArgs[]stringExtra arguments for ‘flanneld’.

apiServer

APIServerConfig represents the kube apiserver configuration options.
FieldTypeDescriptionValue(s)
imagestringThe container image used in the API server manifest.
extraArgsmap[string]stringExtra arguments to supply to the API server.
extraVolumesVolumeMountConfigExtra volumes to mount to the API server static pod.
envEnvThe env field allows for the addition of environment variables for the control plane component.
certSANs[]stringExtra certificate subject alternative names for the API server’s certificate.
disablePodSecurityPolicyboolDisable PodSecurityPolicy in the API server and default manifests.
admissionControlAdmissionPluginConfigConfigure the API server admission plugins.
auditPolicyUnstructuredConfigure the API server audit policy.
resourcesResourcesConfigConfigure the API server resources.

extraVolumes[]

VolumeMountConfig struct describes extra volume mount for the static pods.
FieldTypeDescriptionValue(s)
hostPathstringPath on the host.
mountPathstringPath in the container.
readonlyboolMount the volume read only.

admissionControl[]

AdmissionPluginConfig represents the API server admission plugin configuration.
FieldTypeDescriptionValue(s)
namestring
configurationUnstructured

resources

ResourcesConfig represents the pod resources.
FieldTypeDescriptionValue(s)
requestsUnstructuredRequests configures the reserved cpu/memory resources.
limitsUnstructuredLimits configures the maximum cpu/memory resources a container can use.

controllerManager

ControllerManagerConfig represents the kube controller manager configuration options.
FieldTypeDescriptionValue(s)
imagestringThe container image used in the controller manager manifest.
extraArgsmap[string]stringExtra arguments to supply to the controller manager.
extraVolumesVolumeMountConfigExtra volumes to mount to the controller manager static pod.
envEnvThe env field allows for the addition of environment variables for the control plane component.
resourcesResourcesConfigConfigure the controller manager resources.

extraVolumes[]

VolumeMountConfig struct describes extra volume mount for the static pods.
FieldTypeDescriptionValue(s)
hostPathstringPath on the host.
mountPathstringPath in the container.
readonlyboolMount the volume read only.

resources

ResourcesConfig represents the pod resources.
FieldTypeDescriptionValue(s)
requestsUnstructuredRequests configures the reserved cpu/memory resources.
limitsUnstructuredLimits configures the maximum cpu/memory resources a container can use.

proxy

ProxyConfig represents the kube proxy configuration options.
FieldTypeDescriptionValue(s)
disabledboolDisable kube-proxy deployment on cluster bootstrap.
imagestringThe container image used in the kube-proxy manifest.
modestring
extraArgsmap[string]stringExtra arguments to supply to kube-proxy.

scheduler

SchedulerConfig represents the kube scheduler configuration options.
FieldTypeDescriptionValue(s)
imagestringThe container image used in the scheduler manifest.
extraArgsmap[string]stringExtra arguments to supply to the scheduler.
extraVolumesVolumeMountConfigExtra volumes to mount to the scheduler static pod.
envEnvThe env field allows for the addition of environment variables for the control plane component.
resourcesResourcesConfigConfigure the scheduler resources.
configUnstructuredSpecify custom kube-scheduler configuration.

extraVolumes[]

VolumeMountConfig struct describes extra volume mount for the static pods.
FieldTypeDescriptionValue(s)
hostPathstringPath on the host.
mountPathstringPath in the container.
readonlyboolMount the volume read only.

resources

ResourcesConfig represents the pod resources.
FieldTypeDescriptionValue(s)
requestsUnstructuredRequests configures the reserved cpu/memory resources.
limitsUnstructuredLimits configures the maximum cpu/memory resources a container can use.

discovery

ClusterDiscoveryConfig struct configures cluster membership discovery.
FieldTypeDescriptionValue(s)
enabledbool
registriesDiscoveryRegistriesConfigConfigure registries used for cluster member discovery.

registries

DiscoveryRegistriesConfig struct configures cluster membership discovery.
FieldTypeDescriptionValue(s)
kubernetesRegistryKubernetesConfig
serviceRegistryServiceConfigService registry is using an external service to push and pull information about cluster members.
kubernetes
RegistryKubernetesConfig struct configures Kubernetes discovery registry.
FieldTypeDescriptionValue(s)
disabledboolDisable Kubernetes discovery registry.
service
RegistryServiceConfig struct configures Kubernetes discovery registry.
FieldTypeDescriptionValue(s)
disabledboolDisable external service discovery registry.
endpointstringExternal service endpoint.

etcd

EtcdConfig represents the etcd configuration options.
FieldTypeDescriptionValue(s)
imagestringThe container image used to create the etcd service.
caPEMEncodedCertificateAndKey
extraArgsmap[string]string
advertisedSubnets[]string
listenSubnets[]string

coreDNS

CoreDNS represents the CoreDNS config values.
FieldTypeDescriptionValue(s)
disabledboolDisable coredns deployment on cluster bootstrap.
imagestringThe image field is an override to the default coredns image.

externalCloudProvider

ExternalCloudProviderConfig contains external cloud provider configuration.
FieldTypeDescriptionValue(s)
enabledboolEnable external cloud provider.true
yes
false
no
manifests[]string

inlineManifests[]

ClusterInlineManifest struct describes inline bootstrap manifests for the user.
FieldTypeDescriptionValue(s)
namestring
contentsstringManifest contents as a string.

adminKubeconfig

AdminKubeconfigConfig contains admin kubeconfig settings.
FieldTypeDescriptionValue(s)
certLifetimeDuration